/**
* C_lib Copyright (C) 2022 Wael Karram.
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, version 3 of the License.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

/* This header file defines functions to convert numbers to strings. */
/* Include guards + includes. */
#ifndef NUMTOSTR_H
#define NUMTOSTR_H

/* Include string.h */
#include <string.h>

/* Include stdio.h */
#include <stdio.h>

/* Include assert.h to allow code generation, but only run with debug flag. */
#ifdef DEBUG
#ifndef NDEBUG
#define NDEBUG
#endif	/* NDEBUG. */
#endif	/* DEBUG. */
#include <assert.h>

/* TODO: CHECK CORRECTNESS. */
/* Constants. */
#define NULL_CHAR			'\0'
#define FORMAT_SHORT			"%hd"
#define FORMAT_INT			"%d"
#define FORMAT_UNSIGNED_INT		"%u"
#define FORMAT_DOUBLE			"%f"
#define FORMAT_LONG			"%l"
#define FORMAT_UNSIGNED_LONG		"%l"
#define FORMAT_LONG_LONG		"%ll"
#define FORMAT_UNSIGNED_LONG_LONG	"%ll"
#define FORMAT_FLOAT			"%f"

/* Function declarations. */
/* This function takes a short and prints it to a string. */
static inline char *stostr(short value);
/* This function takes an integer and prints it to a string. */
static inline char *itostr(int value);
/* This function takes an unsigned integer and prints it to a string. */
static inline char *uitostr(unsigned int value);
/* This function takes a double and prints it to a string. */
static inline char *dtostr(double value);
/* This function takes a long and prints it to a string. */
static inline char *ltostr(long value);
/* This function takes an unsigned long and prints it to a string. */
static inline char *ultostr(unsigned long value);
/* This function takes a long long and prints it to a string. */
static inline char *lltostr(long long value);
/* This function takes an unsigned long long and prints it to a string. */
static inline char *ulltostr(long long value);
/* This function takes a float and prints it to a string. */
static inline char *ftostr(float value);

#endif /* NUMTOSTR */
