/**
* C_lib Copyright (C) 2021 Wael Karram.
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, version 3 of the License.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

/* This header file defines a strapp function, for general string appending. */
/* Include guards + includes. */
#ifndef STRAPP_H
#define STRAPP_H
/* Include string.h */
#include <string.h>
/* Include assert.h to allow code generation, but only run with debug flag. */
#ifdef DEBUG
#ifndef NDEBUG
#define NDEBUG
#endif	/* NDEBUG. */
#endif	/* DEBUG. */
#include <assert.h>

/* Constants. */
#define NULL_CHAR	'\0'


/**
* This function takes two strings and appends source to destination, resizing destination if needed.
* Returns the destination address on success and NULL on failure.
*/
static inline char *strapp(char *restrict dest, const char *restrict src, const size_t dest_len, const size_t src_len);

#endif /* STRAPP_H */
